when:
  event: push
  branch: main

steps:
  - name: build-and-push
    image: woodpeckerci/plugin-docker-buildx:4.2.0
    privileged: true
    settings:
      repo: harbor.scottyah.com/scottyah/blog
      dockerfile: Dockerfile
      context: .
      platforms: linux/amd64
      tags:
        - latest
        - ${CI_COMMIT_SHA:0:8}
      logins:
        - registry: https://harbor.scottyah.com
          username:
            from_secret: harbor_username
          password:
            from_secret: harbor_password

  - name: deploy
    image: bitnami/kubectl:latest
    backend_options:
      kubernetes:
        serviceAccountName: woodpecker-deploy
    commands:
      - kubectl apply -f k8s.yaml -n blog
      - kubectl rollout restart deployment/blog-dep -n blog
      - kubectl rollout status deployment/blog-dep -n blog